var _GEL_CHART_COMMON_ = {

    /**
     * 股权穿透
     */
    shareHolderAndInvestChartInitFun: function(chart, rootData, rootCode, rootName) {        
        var option = null,
            treeId = 1;

        // 初始化股权
        if (!rootData.shareHolderTree) {
            rootData.shareHolderTree = {
                Id: rootCode,
                name: '',
                children: null,
                depth: 0,
                type: 'company'
            };
        }
        transTree(rootData.shareHolderTree, 'Id', rootCode, 'stockShare');
        initTree(rootData.shareHolderTree, rootCode);

        // 初始化投资
        treeId = 1;
        if (!rootData.investTree) {
            rootData.investTree = {
                Id: rootCode,
                name: '',
                children: null,
                depth: 0,
                type: 'company'
            };
        }
        transTree(rootData.investTree, 'Id', rootCode, 'parentStockShare', true);
        initTree(rootData.investTree, rootCode);

        drawTheMap();

        function drawTheMap() {
            window._CompanyChart.oldSelectNode = null;
            chart.clear();
            chart._innerOption = option = { // _innerOption记录option
                series: []
            };
            if (rootData.shareHolderTree) {
                option.series.push({
                    type: "tree",
                    orient: "vertical",
                    nodePadding: 25,
                    layerPadding: 40,
                    symbol: "circle",
                    // roam: 'move',
                    roam:true,
                    rootLocation: {
                        "x": "50%",
                        "y": "50%"
                    },
                    direction: "inverse",
                    data: [rootData.shareHolderTree]
                });
            }
            if (rootData.investTree) {
                option.series.push({
                    type: "tree",
                    orient: "vertical",
                    nodePadding: 25,
                    layerPadding: 40,
                    symbol: "circle",
                    // roam: 'move',
                    roam:true,
                    rootLocation: {
                        "x": "50%",
                        "y": "50%"
                    },
                    data: [rootData.investTree]
                })
            }
            if (rootData.shareHolderTree && !rootData.investTree) {
                option.series[0].rootLocation.y = '65%';
            }
            chart.setOption(option);
            _GEL_CHART_COMMON_.initZrender(chart);
            _GEL_CHART_COMMON_.animatieChart(chart);

            chart.getZrender().on("mousedown", function(e) {});
            chart.getZrender().on("mouseup", function(e) {});
            chart.getZrender().on("mousemove", function(e) {});

            function selfClickHandler(e) {                
                // var host = location.href.split('map/')[0] + 'index.html#';
                // if (e.data.code && e.data.type === 'company') {
                //     location.href = host + 'companyDetail?companyCode='+e.data.code;                    
                // } else if (e.data.code && e.data.type == 'person') {
                //     location.href = host + 'person?id='+e.data.code + '&name='+e.data.name;                    
                // }
                var treeNo = e.seriesIndex;
                var treeId = e.data.treeId;
                var depth = e.data.depth;
                var id = e.data.Id;
                var opt = option.series[treeNo];
                var _data = opt.data[0];
                var node = null;
                function findId(data, treeId, depth, id) {
                    if (data.treeId == treeId && data.depth == depth && data.Id == id) {
                        node = data;
                        return;
                    }
                    if (data.children) {
                        for (var i = 0; i < data.children.length; i++) {
                            findId(data.children[i], treeId, depth, id);
                        }
                    }
                }
                findId(_data, treeId, depth, id);        
                if (window._CompanyChart.oldSelectNode === node) {
                    return false;
                }        
                node.itemStyle.normal._borderColor = node.itemStyle.normal.borderColor;
                node.itemStyle.normal._borderWidth = node.itemStyle.normal.borderWidth;
                node.itemStyle.normal.borderColor = '#ff3d00';
                node.itemStyle.normal.borderWidth  = '4';                
                if (window._CompanyChart.oldSelectNode) {
                    window._CompanyChart.oldSelectNode.itemStyle.normal.borderColor = window._CompanyChart.oldSelectNode.itemStyle.normal._borderColor;
                    window._CompanyChart.oldSelectNode.itemStyle.normal.borderWidth = window._CompanyChart.oldSelectNode.itemStyle.normal._borderWidth;
                }
                window._CompanyChart.oldSelectNode = node;
                $('.node-float').find('#node-target').text(node.name);
                $('.node-float').find('.node-float-right').attr('data-code', node.Id).attr('data-type',node.type);
                $('.node-float').show();

                chart.setOption(option);                
            }

            chart.on('click', selfClickHandler);

            chart.getZrender().on('click', function(e) {                
                if (e.target && e.target.clickcom) {
                    if (e.target.children || e.target._children) {
                        // troggleTree(e.target.code, e.target.treeId);
                        troggleTree(e.target.code, e.target.treeId, e.event.clientX, e.event.clientY, e.target);
                    }
                }
            });

            chart.on('restore', function(param) {
                $('.node-float').hide();
                if (window._CompanyChart.oldSelectNode) {
                    window._CompanyChart.oldSelectNode.itemStyle.normal.borderColor = window._CompanyChart.oldSelectNode.itemStyle.normal._borderColor;
                    window._CompanyChart.oldSelectNode.itemStyle.normal.borderWidth = window._CompanyChart.oldSelectNode.itemStyle.normal._borderWidth;
                    window._CompanyChart.oldSelectNode = null;                    
                }
                getNode(rootData.investTree);
                getNode(rootData.shareHolderTree);

                function getNode(data) {
                    if (data.children) {
                        for (var i = 0; i < data.children.length; i++) {
                            getNode(data.children[i]);
                        }
                    }
                    if (data.children && data.children.length > 0 && data.code && data.code != rootCode) {
                        data._children = data.children;
                        data.children = null;
                        data.extend = 1;
                    }
                }
                chart.clear();
                chart.setOption(option);
                _GEL_CHART_COMMON_.initZrender(chart);
                _GEL_CHART_COMMON_.animatieChart(chart);
            });
        }

        /**
         * 数据结构转换
         * 
         * @param {any} data 原始数据
         * @param {any} key 节点键值
         * @param {any} rootCode 根节点Code
         * @param {any} ratioKey 比例字段
         * @param {any} tag 股权结构、对外投资区分(true)
         */
        function transTree(data, key, rootCode, ratioKey, tag) {
            data.treeId = treeId;
            data.code = data[key];

            if (tag) {
                data.isTZ = true; // 投资
            } else {
                data.isGD = true; // 股东
            }

            var children = data.children;
            var fontSize = 15;
            var color = '#333';

            if (data.code !== rootCode) {
                if (!data.name) {
                    data.name = '--';
                }
                // 名称超长字体换小号
                if (data.name.length > 21) {
                    fontSize = 12;
                    data.name = data.name.match(/(.{1,9})/g).join('\n') // 名称7个字换行
                } else {
                    data.name = data.name.match(/(.{1,7})/g).join('\n') // 名称7个字换行
                }
            } else {
                color = '#00AEC7';
            }

            var colorIpo = '#A38E28';
            var colorDebt = '#7D609A';
            // TODO 区分处理
            var borderColor = '#50AFC6';
            // 如果为个人，颜色区分，且不可点击
            if (data.listed || data.listed == 'true') {
                // 上市                
                borderColor = colorIpo;
            } else if (data.issued || data.issued == 'true') {
                // 发债
                borderColor = colorDebt;
            }

            if (data.type && data.Id) {
                data.labelClick = true;
            } else {
                data.labelClick = false;
            }

            var statusColor = '#f4f4f4'; // 异常状态企业

            data.symbol = 'rectangle';
            data.clickable = true;
            data.symbolSize = [120, 62];
            data.itemStyle = {
                normal: {
                    borderRadius: '50%',
                    color: "#fff",
                    // color: (data.type == 'company') ? (data.status ? (data.status.indexOf('存续') > -1 ? '#fff' : statusColor) : (data.reg_status && data.reg_status.indexOf('存续') > -1 ? '#fff' : statusColor)) : '#fff',
                    borderWidth: "2",
                    borderColor: borderColor,
                    label: {
                        show: true,
                        position: "inside",
                        textStyle: {
                            color: color,
                            fontFamily: "MicroSoft YaHei",
                            fontSize: fontSize,
                            fontStyle: "normal",
                        },
                    }
                },
                emphasis: {
                    color: borderColor,
                    borderWidth: 0,
                    label: {
                        show: true,
                        textStyle: {
                            color: '#fff',
                            fontFamily: "MicroSoft YaHei",
                            fontSize: fontSize,
                            fontStyle: "normal"
                        },
                    }
                }
            };

            if (children && children.length) {
                for (var i = 0; i < children.length; i++) {
                    transTree(children[i], key, rootCode, ratioKey, tag);
                    var tmp = children[i];
                    var Ratio = children[i][ratioKey] = children[i][ratioKey] ? children[i][ratioKey] + '' : '';
                    if (Ratio) {
                        Ratio = (parseFloat(children[i][ratioKey]).toFixed(4)) * 10000 / 10000 + '%';
                    } else {
                        Ratio = '--'
                    }
                    children[i] = {
                        name: !tmp._rateHide ? Ratio : '', // 显示/隐藏 持股比例信息
                        _name: Ratio, // 记录持股比例
                        symbol: "arrowdown",
                        symbolSize: [10, 20],
                        tooltip: {
                            show: false
                        },
                        clickable: false,
                        hoverable: false,
                        itemStyle: {
                            normal: {
                                color: "#333",
                                borderWidth: 0,
                                label: {
                                    show: true,
                                    position: "right",
                                    textStyle: {
                                        fontFamily: "MicroSoft YaHei",
                                        fontSize: fontSize,
                                        fontStyle: "normal",
                                    },
                                }
                            },
                            emphasis: {
                                color: "#333",
                                borderWidth: 0,
                                label: {
                                    show: true,
                                    position: "right",
                                    textStyle: {
                                        fontFamily: "MicroSoft YaHei",
                                        fontSize: fontSize,
                                        fontStyle: "normal",
                                    },
                                }
                            }
                        },
                        children: [tmp]
                    }
                }
            } else {
                data.children = [];
            }
            treeId++;
        }

        /**
         * 初始化树，默认展开两层数据，需要将子孙节点收缩处理
         * 
         * @param {any} data 数据
         * @param {any} rootCode 根节点Code
         */
        function initTree(data, rootCode) {
            data.labelClick = false;
            data.clickable = false;
            if (data.depth == 0) {
                data.name = data.name || rootName;
            }
            data.symbolSize = [data.name.length * 16 + 40, 50];
            data.symbol = 'rectangle';
            var color = '#000'
            if (data.code == rootCode) {
                color = '#00AEC7'
            }
            data.itemStyle = {
                normal: {
                    color: "#fff",
                    borderWidth: "2",
                    borderColor: "#50AFC6",
                    label: {
                        show: true,
                        position: "inside",
                        textStyle: {
                            color: color,
                            fontFamily: "MicroSoft YaHei",
                            fontSize: 16,
                            fontStyle: "normal",
                        },
                    }
                },
                emphasis: {
                    color: "#fff",
                    borderWidth: "2",
                    borderColor: "#50AFC6",
                }
            };
            getNode(data);

            function getNode(data) {
                if (data.children) {
                    for (var i = 0; i < data.children.length; i++) {
                        getNode(data.children[i]);
                    }
                }
                if (data.children && data.children.length > 0 && data.code && data.code != rootCode) {
                    data._children = data.children;
                    data.children = null;
                    data.extend = 1;
                }
            }
        }

        function troggleTree(code, tid, x, y, t) {
            if (code == rootCode) {
                return;
            }
            // 持股比例显示/隐藏，默认显示，即字段_rateHide = false
            var rateHide = rootData.shareHolderTree._rateHide ? true : false;
            getNode(rootData.shareHolderTree);
            getNode(rootData.investTree);

            function getNode(data) {
                if (data.code && data.code == code && data.treeId == tid) {
                    if (data.children) {
                        hideRate(data, rateHide);
                        data._children = data.children;
                        data.children = null;
                        data.extend = 1;
                    } else if (data._children) {
                        data.children = data._children;
                        data._children = null;
                        data.extend = 2;
                        hideRate(data, rateHide);
                    }
                    return;
                }
                if (data.children) {
                    for (var i = 0; i < data.children.length; i++) {
                        getNode(data.children[i]);
                    }
                }
            }

            /**
             * 显示/隐藏所有子节点中的持股比例信息
             * 
             * @param {any} data 
             * @param {any} hideVal 
             */
            function hideRate(data, hideVal) {
                if (data.children) {
                    for (var i = 0; i < data.children.length; i++) {
                        hideRate(data.children[i], hideVal);
                    }
                }
                if (data.symbol === 'arrowdown') {
                    data.name = (hideVal ? '' : data._name);
                }
            }

            chart.clear();
            chart.setOption(option);
            _GEL_CHART_COMMON_.initZrender(chart);
        }
    },
    /**
     * echart2实例动画渲染
     * 绘制：股权结构图谱、对外投资图谱、股权穿透图谱
     */
    animatieChart: function(myChart, targetX, targetY) {
        targetX = targetX || 0;
        targetY = targetY || 0;
        var centerX = myChart.getZrender().getWidth() / 2;
        var centerY = myChart.getZrender().getHeight() / 2;
        var layer = myChart.getZrender().painter._layers[1];
        var animation = myChart.getZrender().animation;
        layer.scale = [0.2, 0.2, centerX, centerY];
        layer.rotation = [0, centerX, centerY];
        layer.position = [targetX, targetY];
        layer.position = [targetX, targetY];
        myChart.getZrender().render();

        // 企业详情或其他地方使用时 默认用小号的图形
        if (myChart._wind_scale) {
            animation.animate(layer).when(330, {
                scale: [myChart._wind_scale, myChart._wind_scale, centerX, centerY]
            }).start('spline').done(function() {}).during(function() {
                myChart.getZrender().render();
            });
        } else {
            animation.animate(layer).when(330, {
                scale: [1, 1, centerX, centerY]
            }).start('spline').done(function() {
                layer.scale[2] = 0;
                layer.scale[3] = 0;
            }).during(function() {
                myChart.getZrender().render();
            });
        }
    },
    /**
     * echart2初始化部分附加charts
     * 绘制：股权结构图谱、对外投资图谱、股权穿透图谱
     */
    initZrender: function(myChart) {
        var Text = require('zrender/shape/Text');
        var ImageShape = require('zrender/shape/Image');
        var Rectangle = require('zrender/shape/Rectangle');
        var shapeList = myChart.getZrender().storage.getShapeList();
        for (var i = 0; i < shapeList.length; i++) {
            if (shapeList[i].clickcom) {
                myChart.getZrender().delShape(shapeList[i].id);
            }
            if (shapeList[i].ndelete) {
                myChart.getZrender().delShape(shapeList[i].id);
            }
        }
        for (var i = 0; i < shapeList.length; i++) {
            if (shapeList[i]._echartsData && shapeList[i]._echartsData._data.extend) {
                var iconImg = '';
                if (shapeList[i]._echartsData._data.extend == 1) {
                    iconImg = './img/1.png';

                } else if (shapeList[i]._echartsData._data.extend == 2) {
                    iconImg = './img/2.png';
                }
                var shape = new ImageShape({
                    style: {
                        image: iconImg,
                        x: shapeList[i].rotation[1] - 12,
                        y: shapeList[i]._echartsData._data.isTZ ? shapeList[i].rotation[2] + 31 : shapeList[i].rotation[2] - 54, // 对外投资/股权结构(默认)                            
                        width: 24,
                        height: 24
                    }
                });
                shape.code = shapeList[i]._echartsData._data.code;
                shape.treeId = shapeList[i]._echartsData._data.treeId;
                shape.children = shapeList[i]._echartsData._data.children;
                shape._children = shapeList[i]._echartsData._data._children;
                shape.zlevel = 1;
                shape.z = 4;
                shape.clickcom = true;
                shape.hoverable = true;
                shape.clickable = true;
                myChart.getZrender().addShape(shape);
            }
            if (shapeList[i]._echartsData && shapeList[i]._echartsData._data.actCtrl && shapeList[i]._echartsData._data.benifciary) {
                var shape = new ImageShape({
                    style: {                        
                        image: './img/tupu_kzrsbg.png',
                        x: shapeList[i].rotation[1] - 61,
                        y: shapeList[i].rotation[2] - shapeList[i].style.height / 2 - 64,
                        width: 122,
                        height: 64,
                    },
                    highlightStyle: {
                        lineWidth: 0,
                        strokeColor: '#fff',
                    }
                });
                var shapeText = new Text({
                    style: {
                        x: shapeList[i].rotation[1],
                        y: shapeList[i].rotation[2] - shapeList[i].style.height / 2 - 32,
                        textFont: 'normal 16px 微软雅黑',
                        text: '实际控制人\n' + '最终受益人',
                        textAlign: 'center',
                        color: '#fff',
                        lineWidth: 0,
                        fontWeight: 'bold',
                        lineHeight: '48px'
                    },
                    highlightStyle: {
                        lineWidth: 0,
                        strokeColor: 'rgba(255,255,255,0)',
                    }
                });
                shape.ndelete = true;
                shape.zlevel = 1;
                shape.z = 8;
                shape.hoverable = false;
                shapeText.zlevel = 1;
                shapeText.z = 10;
                shapeText.ndelete = true;
                shapeText.hoverable = false;
                myChart.getZrender().addShape(shape);
                myChart.getZrender().addShape(shapeText);
            } else if (shapeList[i]._echartsData && shapeList[i]._echartsData._data.actCtrl) {
                var shape = new ImageShape({
                    style: {
                        image: './img/tupu_kzrbg.png',
                        x: shapeList[i].rotation[1] - 61,
                        y: shapeList[i].rotation[2] - shapeList[i].style.height / 2 - 36,
                        width: 122,
                        height: 36,
                    },
                    highlightStyle: {
                        lineWidth: 0,
                        strokeColor: 'rgba(255,255,255,0)',
                    }
                });
                var shapeText = new Text({
                    style: {
                        x: shapeList[i].rotation[1],
                        y: shapeList[i].rotation[2] - shapeList[i].style.height / 2 - 20,
                        textFont: 'normal 16px 微软雅黑',
                        text: '实际控制人',
                        textAlign: 'center',
                        color: '#fff',
                        lineWidth: 0,
                    },
                    highlightStyle: {
                        lineWidth: 0,
                        color: '#F5A623',
                        strokeColor: 'rgba(255,255,255,0)',
                    }
                });
                shape.ndelete = true;
                shape.zlevel = 1;
                shape.z = 8;
                shape.hoverable = false;
                shapeText.zlevel = 1;
                shapeText.z = 10;
                shapeText.ndelete = true;
                shapeText.hoverable = false;
                myChart.getZrender().addShape(shape);
                myChart.getZrender().addShape(shapeText);

            } else if (shapeList[i]._echartsData && shapeList[i]._echartsData._data.benifciary) {
                var shape = new ImageShape({
                    style: {
                        image: './img/tupu_syrbg.png',
                        x: shapeList[i].rotation[1] - 61,
                        y: shapeList[i].rotation[2] - shapeList[i].style.height / 2 - 36,
                        width: 122,
                        height: 36,
                    },
                    highlightStyle: {
                        lineWidth: 0,
                        strokeColor: 'rgba(255,255,255,0)',
                    }
                });
                var shapeText = new Text({
                    style: {
                        x: shapeList[i].rotation[1],
                        y: shapeList[i].rotation[2] - shapeList[i].style.height / 2 - 20,
                        textFont: 'normal 16px 微软雅黑',
                        text: '最终受益人',
                        textAlign: 'center',
                        color: '#fff',
                        lineWidth: 0,

                    },
                    highlightStyle: {
                        lineWidth: 0,
                        color: '#F5A623',
                        strokeColor: 'rgba(255,255,255,0)',
                    }
                });
                shape.ndelete = true;
                shape.zlevel = 1;
                shape.z = 8;
                shape.hoverable = false;
                shapeText.zlevel = 1;
                shapeText.z = 10;
                shapeText.ndelete = true;
                shapeText.hoverable = false;
                myChart.getZrender().addShape(shape);
                myChart.getZrender().addShape(shapeText);

            }
        }
    },
    /**
     * canvas、d3 svg保存图片
     * selector：目标元素
     * name：图片名称前缀
     * dType：1,2,3 1-canvas类型 2-d3 svg类型 3-cytoscape类型
     * sData: 原始img数据
     */
    saveCanvasImg: function(selector, name, dType, sData, pwidth, pheight) {

        var name = name || '全球企业库';
        var originalImage = null; // 目标img
        var targetEle = null; // 目标画布元素
        var targetImageData = null; // 目标画布图片数据
        var svgXml = null; // svg xml信息

        // 水印
        var shuiying = new Image();
        shuiying.src = './img/sy.png?t=' + (Date.now()).toString();
        shuiying.width = 200;
        shuiying.height = 115;

        originalImage = new Image();

        // 移除已有jietu遮罩
        if ($('[data-id="jietuMask"]')) {
            $('[data-id="jietuMask"]').remove();
        }
        var jietuMask = document.createElement("div");
        $(jietuMask).attr('data-id', 'jietuMask');
        $(jietuMask).attr('style', 'position: fixed; background: #fff; z-index: 3000; top: 0px; bottom: 0px; left: 0px; right: 0px;');

        if (dType === 3) {
            if (sData) {
                originalImage.onload = function(e) {
                    var canvas = document.createElement('canvas'); //准备空画布
                    canvas.width = originalImage.width;
                    canvas.height = originalImage.height;
                    var context = canvas.getContext('2d'); //取得画布的2d绘图上下文
                    context.fillStyle = "#fff";
                    context.fillRect(0, 0, canvas.width, canvas.height);
                    shuiying.onload = function() {
                        $(jietuMask).css('display', 'none');
                        context.drawImage(originalImage, 0, 0);

                        setTimeout(function() {
                            context.drawImage(shuiying, canvas.width / 2 - 100, canvas.height / 2 - 57, 200, 57); // x,y,w,h
                            var marker = '基于公开信息利用大数据技术独家计算生成!';
                            context.font = "20px 微软雅黑";
                            context.fillStyle = "#aaaaaa";
                            context.fillText(marker, canvas.width / 2 - context.measureText(marker).width / 2, canvas.height - 20);
                            downloadimg(name, canvas);
                        }, 100)

                    }
                }
                document.body.appendChild(jietuMask);
                originalImage.src = sData;
            }
            return;
        } else if (dType === 2) {
            var svgWidth = d3.select(selector + ' svg').attr('width');
            var svgHeight = d3.select(selector + ' svg').attr('height');
            var svgScale = window._CompanyChart.zoom.scale();
            var svgTranslate = window._CompanyChart.zoom.translate();

            if (pwidth && pheight) {
                window._CompanyChart.zoom.translate([20, 20]);
                window._CompanyChart.container.attr("transform", "translate(" + window._CompanyChart.zoom.translate() + ")scale(" + window._CompanyChart.zoom.scale() + ")");
                d3.select('svg').attr('width', pwidth);
                d3.select('svg').attr('height', pheight);
            } else {
                window._CompanyChart.zoom.translate([20, 20]);
                window._CompanyChart.zoom.scale(1);
                window._CompanyChart.container.attr("transform", "translate(" + window._CompanyChart.zoom.translate() + ")scale(" + window._CompanyChart.zoom.scale() + ")");
                d3.select('svg').attr('width', svgWidth);
                d3.select('svg').attr('height', svgHeight);
            }

            // d3 svg 图形
            targetEle = d3.select(selector + ' svg'); // 要保存的图片元素
            svgXml = $(selector).html();
            originalImage.src = 'data:image/svg+xml;base64,' + window.btoa(unescape(encodeURIComponent(svgXml)));

        } else {
            // canvas
            targetEle = $(selector); // 要保存的图片元素
            targetImageData = $(selector)[0].toDataURL();
            originalImage.src = sData || targetImageData;

            originalImage.onload = function(e) {                
                document.body.appendChild(jietuMask);
                var canvas = document.createElement('canvas'); //准备空画布
                canvas.width = originalImage.width;
                canvas.height = originalImage.height;
                var context = canvas.getContext('2d'); //取得画布的2d绘图上下文
                context.fillStyle = "#fff";
                context.fillRect(0, 0, canvas.width, canvas.height);
                // shuiying.onload = function() {                    
                    $(jietuMask).css('display', 'none');
                    context.drawImage(originalImage, 0, 0);
                    
                    setTimeout(function() {                        
                        context.drawImage(shuiying, canvas.width / 2 - 100, canvas.height / 2 - 57, 200, 57); // x,y,w,h
                        var marker = '基于公开信息利用大数据技术独家计算生成!';
                        context.font = "0.37rem 微软雅黑";
                        context.fillStyle = "#aaaaaa";
                        context.fillText(marker, canvas.width / 2 - context.measureText(marker).width / 2, canvas.height - 20);
                        downloadimg(name, canvas);
                    })
                // }
            }

            originalImage.onerror = function () {
                window.alert('图片资源过大, 保存失败, 请重新尝试');
            }

            return;
        }

        /**
         * 生成img
         * 
         * @param {any} selector , canvas元素选择符
         * @param {any} dType , dType
         */
        function saveImg(selector, dType) {

            setTimeout(function() {
                var canvas = document.createElement('canvas'); //准备空画布
                canvas.width = pwidth || targetEle.attr('width');
                canvas.height = pheight || targetEle.attr('height');

                if (dType === 2) {
                    window._CompanyChart.zoom.scale(svgScale);
                    window._CompanyChart.zoom.translate(svgTranslate);
                    window._CompanyChart.container.attr("transform", "translate(" + window._CompanyChart.zoom.translate() + ")scale(" + window._CompanyChart.zoom.scale() + ")");
                    d3.select('svg').attr('width', svgWidth);
                    d3.select('svg').attr('height', svgHeight);
                }

                $(jietuMask).css('display', 'none');
                var context = canvas.getContext('2d'); //取得画布的2d绘图上下文
                context.fillStyle = "#fff";
                context.fillRect(0, 0, canvas.width, canvas.height);

                // 水印
                try {
                    shuiying.onload = function() {
                        context.drawImage(originalImage, 0, 0);
                        if (dType === 2) {
                            context.drawImage(shuiying, canvas.width / 2 - 100, canvas.height / 2 - 28, 200, 57); // x,y,w,h
                        } else {
                            context.drawImage(shuiying, canvas.width / 2 - 100, canvas.height / 2 - 57, 200, 57); // x,y,w,h
                        }
                        var marker = '基于公开信息利用大数据技术独家计算生成!';
                        context.font = "0.37rem 微软雅黑";
                        context.fillText(marker, canvas.width / 2 - context.measureText(marker).width / 2, canvas.height - 20);
                        downloadimg(name, canvas);
                    }
                } catch (e) {
                    context.drawImage(originalImage, 0, 0);
                    var marker = '基于公开信息利用大数据技术独家计算生成!';
                    context.font = "0.37rem 微软雅黑";
                    context.fillText(marker, canvas.width / 2 - context.measureText(marker).width / 2, canvas.height - 20);
                    downloadimg(name, canvas);
                }
            }, 10);
        }

        /**
         * 将canvas保存本地img
         * 
         * @param {any} name , img前缀
         * @param {any} canvas , canvas对象
         */
        function downloadimg(name, canvas) {            
            var href = window.location.href;            
            var qual = 0.5; // 图片质量
            if (canvas.width > 5000) {
                qual = 0.1;
            } else if (canvas.width > 3000) {
                qual = 0.3;
            } else if (canvas.width > 2000) {
                qual = 0.5;
            }            
            if (window.location.href.indexOf('ysgx.html') > -1) {
                try {
                    // 疑似关系 单独处理                    
                    var osTyle = _GEL_CHART_COMMON_.getOSType();
                    var maps = window._CompanyChart._Relation;
                    if (osTyle == 'ios') {
                        var devicePixelRatio = window.devicePixelRatio || 1;
                        if (devicePixelRatio < 3) {
                            // 如果是低配手机 则分辨率降低处理                            
                            if (maps.dataSet.entities.length > 51) {
                                qual = 0.05;                                    
                            } else {
                                qual = 0.1;
                            }
                        } else {                            
                            qual = 0.1;                            
                        }
                    } else {
                        if (maps.dataSet.entities.length < 51) {
                            qual = 0.2;                                    
                        } else {
                            qual = 0.1;
                        }                        
                    }
                }
                catch (e) {
                    qual = 0.1;            
                }
            }
            //设置保存图片的类型            
            var imgdata = canvas.toDataURL('image/jpeg', qual);
            var d = new Date().toLocaleDateString();
            d = d.replace(/\//g,'_');
            var filename = name + '_' + d + '.jpeg';            
            if (window.shellObj) {
                window.shellObj.GELSaveIMg(imgdata, filename);
                return;
            }            
            var a = document.createElement('a')
            var event = new MouseEvent('click');
            a.download = filename;
            a.href = imgdata;
            a.dispatchEvent(event)
        }
        saveImg(selector, dType);
    },
    /**
     * echart2保存图片
     */
    saveEchart2Img: function(chart, name, eleParam) {
        var width = 1440;
        var height = 900;

        var minX = 0;
        var maxX = 0;
        var minY = 300;
        var maxY = 0;
        var moveDown = 0;
        var moveRight = 0;

        var shapeList = chart.getZrender().storage.getShapeList();
        for (var i = 0; i < shapeList.length; i++) {
            if (shapeList[i].style && shapeList[i].style.iconType == 'rectangle') {
                if (shapeList[i].style.x > maxX) {
                    maxX = shapeList[i].style.x;
                }
                if (shapeList[i].style.x < minX) {
                    minX = shapeList[i].style.x;
                }
                if (shapeList[i].style.y > maxY) {
                    maxY = shapeList[i].style.y;
                }
                if (shapeList[i].style.y < minY) {
                    minY = shapeList[i].style.y;
                }
            }
        }

        if ((maxX - minX + 300) > width) {
            width = maxX - minX + 300;
            moveRight = -(maxX + minX - chart.getZrender().getWidth() + 146) / 2;

        }
        if ((maxY - minY + 300) > 900) {
            height = maxY - minY + 300;
        }

        moveDown = -(maxY + minY - chart.getZrender().getHeight()) / 2 - 85;

        var layer = chart.getZrender().painter._layers[1];
        var bS = layer.scale.concat();
        var bP = layer.position.concat();

        layer.scale = [1, 1, 0, 0];
        layer.position = [0, 0];

        var owidth = $(eleParam).width();
        var oheight = $(eleParam).height();

        $(eleParam).width(width);
        $(eleParam).height(height);
        $(eleParam).hide();

        chart.resize();

        chart.getZrender().painter.refresh();

        _GEL_CHART_COMMON_.initZrender(chart);

        layer.position[0] = moveRight;
        layer.position[1] = moveDown;

        setTimeout(function() {
            var canvas = $(eleParam + ' canvas')[0];
            var imgdata = canvas.toDataURL();
            _GEL_CHART_COMMON_.saveCanvasImg(eleParam + ' canvas', name, 1, imgdata);
            $(eleParam).width(owidth);
            $(eleParam).height(oheight);
            chart.resize();
            layer.scale = bS;
            layer.position = bP;
            chart.getZrender().painter.refresh();
            _GEL_CHART_COMMON_.initZrender(chart);            
            $(eleParam).show();
        }, 400);
    },
    getUrlSearch: function(params) {        
        var loc = location.href;
        if (loc.replace) {
            loc = loc.replace(/companycode/i, 'companycode')
        }
        var pattern = new RegExp(params + '=([^&#|]+)#?');
        var patternArr = pattern.exec(loc);
        if (patternArr) {
            return patternArr[1]
        } else {
            return "";
        }
    },   
    /**
     * 疑似关系
     */
    loadYSGX: function(code_, name_, id_, data_) {
        // TODO 1. 绘制页面 2.实现功能

        var Relation = {
            companyCode: code_,
            companyName: name_,
            companyId: id_,
            dataSet: null,
            cloneDataSet: {},
        };

        initData();

        function initData() {            
            var data = data_;
            if (data.ErrorCode == 0 && data.Data) {
                var dataSet = Relation.dataSet;
                if (data.Data.nodes && data.Data.nodes.length && data.Data.routes && data.Data.routes.length) {
                    dataSet = Relation.dataSet = _GEL_CHART_COMMON_.chartAllDataChange(data.Data);
                    var tmp = []; // 避免后端生成的节点无序
                    var levelObj = {};
                    var stateObj = {};

                    for (var i = 0; i < data.Data.nodes.length; i++) {
                        var t = data.Data.nodes[i];
                        if (dataSet.nodeObj[t.windId]) {
                            tmp.push(dataSet.nodeObj[t.windId]);
                        }

                        // TODO 兼容后端bug
                        var state = '';
                        if (t.status) {
                            state = t.status;
                        } else if (t.props && t.props.status) {
                            state = t.props.status
                        }
                        var level = t.level;

                        if (levelObj[level]) {
                            if (!levelObj[level][t.windId]) {
                                levelObj[level][t.windId] = t;
                            }
                        } else {
                            levelObj[level] = {};
                            levelObj[level][t.windId] = t;
                        }

                        if (t.nodeType === 'company') {
                            if (stateObj[state]) {
                                if (!stateObj[state][t.windId]) {
                                    stateObj[state][t.windId] = t;
                                }
                            } else {
                                stateObj[state] = {};
                                stateObj[state][t.windId] = t;
                            }
                        }
                    }
                    dataSet.levelObj = levelObj;
                    dataSet.stateObj = stateObj;
                    dataSet.nodes = tmp;
                    var pathSet = Relation.chartPathSet = _GEL_CHART_COMMON_.chartPathChange(data.Data.paths);
                    Relation._corpListParams = {};
                    Relation._corpListParams.pathSet = pathSet.pathObj;
                    Relation._corpListParams.companycode = '';

                    var _rootNode = null;

                    // 记录当前有多少企业节点(剔除目标公司)
                    for (var iii = 0; iii < dataSet.nodes.length; iii++) {
                        var item = dataSet.nodes[iii];
                        if (item.nodeType == 'company' && (item.windId.indexOf('$') < 0)) {
                            if (item.windId !== Relation.companyCode) {
                                if (Relation._corpListParams.companycode) {
                                    Relation._corpListParams.companycode += (',' + item.windId);
                                } else {
                                    Relation._corpListParams.companycode = item.windId;
                                }
                            }
                        }
                        if (item.windId === Relation.companyCode) {
                            _rootNode = item;
                        }
                    }
                } else {
                    dataSet = Relation.dataSet = {
                        nodes: [{
                            level: 0,
                            nodeName: window._CompanyChart.companyName,
                            windId: window._CompanyChart.companyCode
                        }],
                        routes: [],
                        paths: []
                    }
                    Relation._corpListParams = {};
                    Relation._corpListParams.companycode = '';
                }
                $.extend(true, Relation.cloneDataSet, dataSet);

                window._CompanyChart._Relation = Relation;
                initMap();
            }  
        }

        function initMap() {
            try {                
                Relation.cyInstance = _GEL_CHART_COMMON_.relationChartInitFun(Relation.dataSet, { code: Relation.companyCode }, $('#companyChart')[0], '635', 0.9, true);                                
            } catch (e) {
                // TODO 加载失败
                $('#load_data').hide();
                $('#no_data').show();
                return;
            }

            function saveAction(e) {                               
                try {
                    if ($('#load_data').attr('style').indexOf('block') > -1) {
                        return false;
                    }
                var imgData = Relation.cyInstance.jpg({ full: true, bg: '#ffffff', scale: 0.6 });
                    var target = $('[data-id="layer2-node"]')
                    _GEL_CHART_COMMON_.saveCanvasImg('[data-id="layer2-node"]', Relation.companyName + '_疑似关系', 3, imgData)
                }
                catch(e) {
                    // 移除已有jietu遮罩
                    if ($('[data-id="jietuMask"]')) {
                        $('[data-id="jietuMask"]').remove();
                    }
                    alert('图片生成失败, 请重试!');
                }
            }

            function reloadAction(e) {      
                $('.node-float').hide();          
                if ($('#load_data').attr('style').indexOf('block') > -1) {
                    return false;
                }                
                $("#companyChart").empty(); // 节点清空
                $("#companyChart").attr('class', '').css('height',0); // 样式清空     
                $('#load_data').show();                
                var tmpData = {};
                $.extend(true, tmpData, Relation.cloneDataSet);
                Relation.cyInstance = null;
                setTimeout(function() {
                    $("#companyChart").css('height','95vh'); // 样式清空     
                    Relation.cyInstance = _GEL_CHART_COMMON_.relationChartInitFun(tmpData, { code: Relation.companyCode }, $('#companyChart')[0], '640', 0.9, true);                                    
                    $('#load_data').hide();
                }, 500)
            }

            /**
             * 退出
             */
            function exitAction() {
                if (window.shellObj) {                    
                    if (_GEL_CHART_COMMON_.getOSType() == 'android') {
                        window.shellObj.Close();
                    } else {                                        
                        window.shellObj.CloseLandWin && window.shellObj.CloseLandWin();
                    }
                } else {
                    if (window.__WEAPPBACK__) {
                        // 微信小程序返回
                        window.wx.miniProgram.navigateBack();
                    } else {
                        window.history.back();
                    }                    
                }
            }

            $('.chart-header-exit').off('click').on('click', exitAction);
            $('.chart-header-reload').off('click').on('click', reloadAction);
            $('.chart-header-save').off('click').on('click', saveAction);

        }
    }, 
        /**
     * 图谱：数据结构变化
     * @param 初始data
     * @return 变更后数据结构：节点集合、连线集合，节点对象、连线对象
     */
    chartAllDataChange: function(data) {
        var paths = data.paths;
        var nodeObj = {}; // node 对象，有唯一key
        var routeObj = {}; // route 对象，有唯一key
        var nodes = []; // node arr
        var links = []; // route arr

        for (var i = 0; i < paths.length; i++) {
            var nodeInPath = paths[i].nodes;
            if (nodeInPath.length > 3) {
                nodeInPath.length = 3;
            }
            for (var j = 0; j < nodeInPath.length; j++) {
                var node = nodeInPath[j];
                if (!nodeObj[node.windId]) {
                    nodeObj[node.windId] = node;
                    nodes.push(node);
                } else {
                    nodeObj[node.windId].level = node.level;
                }
            }
        }

        for (var i = 0; i < data.routes.length; i++) {
            var route = data.routes[i];
            var startId = route.startId;
            var endId = route.endId;
            var _routeId = route.startId + '_' + route.endId;
            route._routeId = _routeId;
            if (nodeObj[startId] && nodeObj[endId]) {
                links.push(route);
            }
            if (!routeObj[_routeId]) {
                routeObj[_routeId] = route;
            }
        }
        return { nodes: nodes, routes: links, nodeObj: nodeObj, routeObj: routeObj };
    },
    /**
     * 图谱：路径数据结构变化
     * @param 原始paths
     * @return 变更后数据结构：节点对应的path对象、关联关系路径对象、所有path对象、企业状态path对象
     */
    chartPathChange: function(paths) {

        var pathObj = {}; // 所有的点对应的path对象，key为节点id
        var filterPathObj = {}; // 所有的label obj,key为label, 关联关系 
        var allPathObj = {}; // 所有的path obj,key为pathid
        var statePathObj = {}; // 所有的state obj,key为state, 企业状态

        var txtObj = {
            'actctrl': '控制',
            'branch': '分支机构',
            'invest': '投资',
            'legalrep': '法人',
            'member': '高管',
            'investctrl': '控股'
        }

        for (var j = 0; j < paths.length; j++) {
            var nodes = paths[j].nodes;
            var node = nodes[nodes.length - 1];
            var routes = paths[j].routes;

            var _p = '';
            for (var m = 0; m < nodes.length; m++) {
                _p = _p ? _p + '|' + nodes[m].windId : nodes[m].windId;
            }

            if (!allPathObj[_p]) {
                paths[j]._pathId = _p;
                allPathObj[_p] = paths[j];
            }

            if (!pathObj[node.windId]) {
                pathObj[node.windId] = { arr: [], obj: {} };
                pathObj[node.windId].arr.push(nodes);
                pathObj[node.windId].obj[_p] = nodes;
                pathObj[node.windId].obj[_p]._path = routes;
            } else {
                pathObj[node.windId].arr.push(nodes);
                pathObj[node.windId].obj[_p] = nodes;
                pathObj[node.windId].obj[_p]._path = routes;
            }

            routes.forEach(function(t) {
                var _routeId = t.startId + '_' + t.endId;
                t._routeId = _routeId;
                var types = t.relType.split('|'); // invest|member

                t.filters = {};
                t.filtersWithPercent = {}; // 带投资、控股比例的字段

                types.forEach(function(type) {
                    filterPathObj[type] = filterPathObj[type] || [];
                    filterPathObj[type].push(paths[j]);
                    var txt = txtObj[type] || '';
                    if (type === 'member') {
                        txt = t.props.member_props.position;
                    }
                    t.filters[type] = { show: true, txt: txt };
                    t.filtersWithPercent[type] = { show: true, txt: txt };
                    if (type === 'invest' || type === 'actctrl' || type === 'investctrl') {
                        var p = t.props[type + '_props'].rate || '';
                        p = p ? _GEL_CHART_COMMON_.formatPercent(p) : '';
                        t.filtersWithPercent[type] = { show: true, txt: p ? txt + '(' + p + ')' : txt };
                    }
                })
            })

            nodes.forEach(function(t) {
                var id = t.windId;
                if (t.nodeType !== 'company') {
                    return;
                }
                if (!statePathObj[id]) {
                    statePathObj[id] = [];
                    statePathObj[id].push(paths[j])
                } else {
                    statePathObj[id].push(paths[j])
                }
            })
        }

        return { pathObj: pathObj, filterPathObj: filterPathObj, allPathObj: allPathObj, statePathObj: statePathObj };
    },
    /**
     * 疑似关系
     */
    relationChartInitFun: function(root, params, eleParam, heightParam, levelParam, hideParam) {
        var nodes;
        var links;
        var cy;
        var imgServerIp = '180.96.8.44';

        function maoRefresh() {
            // cy.reset();
            // cy.center(cy.$('#' + nodeCenter));
            // var vData = {};
            // $.extend(true, vData, rootData);
            // drawGraph(vData);
            $('.btn-search').trigger('click')
        }

        function getData() {
            drawGraph(root);
        }
        var nodeCenter = params.code;
        var colorCenter = '#e26012';
        var colorLeft = '#e26012';
        var colorRight = '#e26012';
        var colorRY = '#B91818';
        var colorQT = '#0085ad';
        var colorLink = '#fbd14c';
        var colorIpo = '#A38E28';
        var colorDebt = '#7D609A';

        var allColor = '#666666';
        var allColors = ['#9d7fd1', '#e46258', '#fe9d4e', '#fbd14c', '#3cc73e', '#4eb486', '#3db6c6', '#54a4eb', '#1e88e5', '#e26012'];
        var allColorsObj = {
            'actctrl': {
                idx: 0,
                txt: '控制',
                props: null,
            },
            'address': {
                idx: 1,
                txt: '',
                // txt: '地址',
                // props: 'address',
                props: null
            },
            'branch': {
                idx: 2,
                txt: '分支机构',
                props: null,
            },
            'domain': {
                idx: 3,
                txt: '',
                // txt: '域名',
                // props: 'domain',
                props: null
            },
            'invest': {
                idx: 4,
                txt: '投资',
                props: null,
            },
            'legalrep': {
                idx: 5,
                txt: '法人',
                props: null,
            },
            'member': {
                idx: 6,
                txt: '高管',
                props: 'position',
            },
            'tel': {
                idx: 7,
                txt: '',
                // txt: '电话',
                // props: 'tel',
                props: null
            },
            'email': {
                idx: 8,
                txt: '',
                // txt: '邮件',
                // props: 'email',
                props: null
            },
            'investctrl': {
                idx: 9,
                txt: '控股',
                props: null
            }
        };

        function drawGraph(data) {

            var clientWidth = window.document.body.clientWidth;

            // 关联路径探查
            var eles = [];
            var activeNode;
            var moveTimeer;
            var _isFocus = false;

            data.entities = []
            data.route = []

            data.nodes.forEach(function(t) {
                var node = {};
                if (t.windId == nodeCenter) {
                    if (t.nodeType == 'person') {
                        node = {
                            "Id": t.windId,
                            "Name": t.nodeName || '目标人物',
                            "Type": t.nodeType,
                            "rootNode": true,
                            color: colorCenter,
                            imgId: t.imageId || ''
                        }
                    } else {
                        node = {
                            "Id": t.windId,
                            "Name": t.nodeName || '目标公司',
                            "Type": t.nodeType,
                            "rootNode": true,
                            color: colorCenter
                        }
                    }
                } else if (t.nodeType == 'person') {
                    node = {
                        "Id": t.windId,
                        "Name": t.nodeName || 'N/A',
                        "category": t.nodeType,
                        color: colorRY,
                        imgId: t.imageId || ''
                    }
                } else if (t.nodeType == 'email' || t.nodeType == 'domain' || t.nodeType == 'address' || t.nodeType == 'tel') {
                    node = {
                        "Id": t.windId,
                        "Name": t.nodeName || 'N/A',
                        "category": t.nodeType,
                        color: colorLink
                    }
                } else {
                    node = {
                        "Id": t.windId,
                        "Name": t.nodeName || 'N/A',
                        "category": t.nodeType
                    }
                    if (t.isListed == 'true') {
                        node.color = colorIpo;
                        node.isListed = true;
                    } else if (t.isIssued == 'true') {
                        node.color = colorDebt;
                        node.isIssued = true;
                    } else {
                        node.color = colorQT;
                    }
                }
                var len = node.Name.length;
                // 文本长度在15以内 不处理
                // 中文超过15处理
                // 英文超过30处理
                if (len > 16) {
                    var cnLen = 0;
                    for (var j = 0; j < len; j++) {
                        // 遍历判断字符串中每个字符的Unicode码,大于255则为中文
                        if (node.Name.charCodeAt(j) > 255) {
                            cnLen += 1;
                        }
                    }
                    var enLen = len - cnLen;
                    var charLen = cnLen * 2 + enLen;
                    node.charLength = cnLen * 2 + enLen;
                }
                eles.push({
                    data: {
                        id: node.Id,
                        name: node.Name,
                        category: t.nodeType,
                        color: node.color,
                        isListed: node.isListed,
                        isIssued: node.isIssued,
                        imgId: node.imgId || '',
                        charLength: node.charLength || null
                    }
                });
                data.entities.push(node);
            })
            delete data.nodes;
            data.routes.forEach(function(link) {

                var type = link.relType.split('|');
                var label = '';
                var props = link.props;
                var color = '';

                if (type.length > 1) {
                    for (var _i = 0; _i < type.length; _i++) {
                        var t = type[_i];
                        var propObj = link.props[t + '_props'];
                        var prop = '';
                        var _label = '';

                        if (allColorsObj[t]) {
                            prop = allColorsObj[t].props ? propObj[allColorsObj[t].props] : '';
                            _label = allColorsObj[t].txt;
                        }

                        if (t === 'member') {
                            _label = prop;
                        }

                        if (label) {
                            label = label + ', ' + _label;
                        } else {
                            label = _label;
                        }
                    }
                    eles.push({
                        data: {
                            source: link.startId,
                            target: link.endId,
                            label: label,
                            _label: label,
                            color: allColor,
                            sourceNode: link.sourceNode,
                            endNode: link.targetNode,
                            _routeId: link._routeId
                        },
                        classes: 'autorotate'
                    });
                } else {

                    if (allColorsObj[link.relType]) {
                        if (allColorsObj[link.relType].props) {
                            var propObj = link.props ? link.props[link.relType + '_props'] : null;
                            props = propObj ? propObj[allColorsObj[link.relType].props] : '';
                            color = allColors[allColorsObj[link.relType].idx];
                        } else {
                            props = '';
                            color = allColors[allColorsObj[link.relType].idx];
                        }
                        label = allColorsObj[link.relType].txt;
                    } else {
                        label = '';
                        props = '';
                        color = allColor;
                    }

                    if (link.relType === 'member') {
                        label = props;
                    }

                    eles.push({
                        data: {
                            source: link.startId,
                            target: link.endId,
                            label: label,
                            _label: label,
                            color: color,
                            sourceNode: link.sourceNode,
                            endNode: link.targetNode,
                            _routeId: link._routeId
                        },
                        classes: 'autorotate'
                    });
                }
                data.route.push(link)
            });
            delete data.routes;
            data.routes = data.route;
            delete data.route;
            cy = cytoscape({
                container: eleParam,
                motionBlur: false,
                textureOnViewport: false,
                wheelSensitivity: 0.1,
                elements: eles,
                minZoom: 0.6,
                maxZoom: 1.6,
                layout: {
                    name: 'cose',
                    fit: false,
                    componentSpacing: 40,
                    nestingFactor: 12,
                    padding: 10,
                    edgeElasticity: 800,
                    idealEdgeLength: function(edge) {
                        return 10;
                    },
                    ready: function() {
                        $("#screenArea").css("cursor", "pointer");
                        var nodeLength = cy.collection("node").length;
                        if (nodeLength < 8) {
                            cy.zoom({ level: 1.4 })
                        } else if (nodeLength >= 8 && nodeLength < 16) {
                            cy.zoom({ level: 1.3 })
                        } else if (nodeLength >= 15 && nodeLength < 25) {
                            cy.zoom({ level: 1.1 })
                        } else {
                            cy.zoom({ level: 1.01 })
                        }
                        //默认显不显示关系文字，比如“董事”
                        if (!cy.txtHide) {
                            cy.collection("edge").addClass("hidetext")
                        }
                    },
                    sort: function(a, b) {
                        return b.data('category') - a.data('category')
                    }
                },
                style: [{
                        // 节点初始状态
                        selector: 'node',
                        style: {
                            shape: 'ellipse',
                            width: function(ele) {
                                if (ele.data('charLength') && ele.data('charLength') > 31) {
                                    return 77 + (ele.data('charLength') - 30) * 1;
                                }
                                if (ele.data("category") == "person") {
                                    return 56;
                                } else if (ele.data("category") == "email" || ele.data("category") == "domain" || ele.data("category") == "address" || ele.data("category") == "tel") {
                                    return 47;
                                } else {
                                    return 77;
                                }                                
                            },
                            height: function(ele) {
                                if (ele.data('charLength') && ele.data('charLength') > 31) {
                                    return 77 + (ele.data('charLength') - 30) * 1;
                                }
                                if (ele.data("category") == "person") {
                                    return 56;
                                } else if (ele.data("category") == "email" || ele.data("category") == "domain" || ele.data("category") == "address" || ele.data("category") == "tel") {
                                    return 47;
                                } else {
                                    return 77;
                                }                                
                            },
                            'background-color': function(ele) {
                                return ele.data('color')
                            },
                            'background-image': function(ele) {
                                // if (ele.data('id') === nodeCenter && ele.data("category") == 'company') {
                                //     return '../resource/images/chart/c-company.png';
                                // } else if (ele.data('id') === nodeCenter && ele.data("category") == "person") {
                                //     return '../resource/images/chart/c-person.png';
                                // } else if (ele.data("category") == "person") {
                                //     return '../resource/images/chart/person.png';
                                // } else if (ele.data("category") == "email") {
                                //     return '../resource/images/chart/email.png';
                                // } else if (ele.data("category") == "domain") {
                                //     return '../resource/images/chart/url.png';
                                // } else if (ele.data("category") == "address") {
                                //     return '../resource/images/chart/address.png';
                                // } else if (ele.data("category") == "tel") {
                                //     return '../resource/images/chart/tel.png';
                                // } else {
                                //     return '../resource/images/chart/company.png';
                                // }
                                
                                // var imgId = ele.data('imgId');
                                // if (imgId && imgServerIp) {
                                //     return 'http://' + imgServerIp + '/imageWeb/ImgHandler.aspx?imageID=' + imgId;
                                // } else {
                                //     return 'none';
                                // }
                                return 'none';                              
                            },
                            // 'background-image-crossorigin': 'no', // TODO 单独加的字段
                            'background-fit': 'cover cover',
                            'background-width': '100%',
                            'background-height': '100%',
                            'background-image-opacity': 0.8,
                            'border-color': function(ele) {                                
                                // var imgId = ele.data('imgId');
                                // if (imgId && imgServerIp) {
                                //     return 'red'
                                // } else {
                                //     return '#fff';
                                // }                 
                                return '#fff';               
                            },
                            'border-width': 6,
                            'border-opacity': function(ele) {                             
                                // var imgId = ele.data('imgId');
                                // if (imgId && imgServerIp) {
                                //     return 0.5
                                // } else {
                                //     return 0;
                                // }   
                                return 0;                         
                            },
                            label: function(ele) {
                                var label = ele.data("name");
                                if (label.indexOf(' ') > 0) {
                                    var arr = label.split(' ');
                                    var tmp = ''
                                    for (var i = 0; i < arr.length; i++) {
                                        tmp += (tmp ? '\n' + arr[i] : arr[i]);
                                    }
                                    label = tmp;
                                    // label = label ? label.replace(/(.{5})(?=.)/g, '$1\n') : 'N/A';
                                } else {
                                    label = label ? label.replace(/(.{5})(?=.)/g, '$1\n') : 'N/A';
                                }
                                return label;
                            },
                            // 'text-outline-color': 'lime',
                            // 'text-outline-width': '5',
                            // 'text-outline-opacity': '0.2',
                            // 'text-border-width': '5',
                            // 'text-border-style': 'solid',
                            // 'text-border-color': 'lime',
                            // 'text-border-opacity': 1,
                            // 'ghost': 'yes',
                            // 'ghost-opacity': 1,
                            // 'ghost-offset-x': 20,
                            // 'ghost-offset-y': 20,
                            // 'text-margin-y': 3,
                            'z-index-compare': 'manual',
                            'z-index': 20,
                            color: "#fff",
                            'font-size': function() {
                                return 14;
                            },
                            'font-family': 'MicroSoft YaHei',
                            'text-wrap': 'wrap',
                            // 'text-max-width': 60,
                            'text-halign': 'center',
                            'text-valign': 'center',
                            'overlay-color': '#fff',
                            'overlay-opacity': 0,
                            "background-opacity": 1,
                            // 'border-width': 10,
                            // 'border-opacity': 0.1,
                            // 'border-style': 'solid',
                            // 'border-color': function(ele) {
                            // if (ele.data('id') === CompanyChart.companyCode) {
                            //     return colorDQ
                            // } else if (ele.data("category") == "person") {
                            //     return colorRy
                            // } else {
                            //     return colorQT
                            // }
                            // return '#666666'
                            // }
                        }
                    },
                    {
                        // 连线初始状态
                        selector: 'edge',
                        style: {
                            "line-style": 'solid',
                            'curve-style': 'bezier',
                            'control-point-step-size': 20,
                            'target-arrow-shape': 'triangle-backcurve',
                            'target-arrow-color': function(ele) {
                                return "#666666";
                            },
                            'arrow-scale': 0.5,
                            'line-color': function(ele) {
                                return ele.data("color");
                            },
                            'background-color': function(ele) {
                                return ele.data("color");
                            },
                            'width': 0.3,
                            'overlay-color': '#fff',
                            'overlay-opacity': 0,
                            label: function(ele) {
                                return ele.data("label");
                            },
                            'text-opacity': 1,
                            'font-size': 12,
                            'font-family': 'MicroSoft YaHei',
                            'color': function(ele) {
                                return allColor;
                            },
                        }
                    },
                    {
                        // 边上的文字旋转样式
                        "selector": ".autorotate",
                        "style": {
                            // 边上的文字是否跟随边旋转
                            // "edge-text-rotation": "autorotate"                                    
                        }
                    },
                    {
                        selector: '.nodeActive',
                        style: {
                            'background-color': function(ele) {
                                return ele.data('color')
                            },
                            'border-color': function(ele) {
                                if (ele.data('id') === nodeCenter) {
                                    return colorCenter;
                                } else if (ele.data("category") == "person") {
                                    return colorRY
                                } else if (ele.data("category") == "address" || ele.data("category") == "domain" || ele.data("category") == "email" || ele.data("category") == "tel") {
                                    return colorLink
                                } else {
                                    if (ele.data('isListed')) {
                                        return colorIpo;
                                    } else if (ele.data('isIssued')) {
                                        return colorDebt;
                                    } else {
                                        return colorQT
                                    }
                                }
                            },
                            'border-width': 10,
                            'border-opacity': 0.5,
                            width: function(ele) {
                                if (ele.data('charLength') && ele.data('charLength') > 31) {
                                    return 79 + (ele.data('charLength') - 30) * 1;
                                }
                                if (ele.data("category") == "person") {
                                    return 56;
                                } else if (ele.data("category") == "company") {
                                    return 79;
                                } else {
                                    return 45;
                                }
                            },
                            height: function(ele) {
                                if (ele.data('charLength') && ele.data('charLength') > 31) {
                                    return 79 + (ele.data('charLength') - 30) * 1;
                                }
                                if (ele.data("category") == "person") {
                                    return 53;
                                } else if (ele.data("category") == "company") {
                                    return 79;
                                } else {
                                    return 43;
                                }
                            },
                        }
                    },
                    {
                        selector: '.nodeHide',
                        style: {
                            opacity: 0,
                            'z-index': 999,
                        }
                    },
                    {
                        selector: '.edgeHide',
                        style: {
                            opacity: 0
                        }
                    },
                    {
                        selector: '.edgeShow',
                        style: {
                            'color': '#666666',
                            'text-opacity': 1,
                            'font-weight': 400,
                            label: function(ele) {
                                return ele.data("label");
                            },
                            'font-size': 12,
                        }
                    },
                    {
                        // 初始状态 线条颜色；鼠标悬浮node时 线条颜色；
                        selector: '.edgeActive',
                        style: {
                            "line-style": 'solid',
                            "arrow-scale": 0.8,
                            'width': 1.5,
                            'color': '#666666',
                            'text-opacity': 1,
                            'font-size': 12,
                            'font-weight': '600',
                            'text-background-color': '#fff',
                            'text-background-opacity': 1,
                            "source-text-margin-y": 20,
                            "target-text-margin-y": 20,
                            'z-index-compare': 'manual',
                            'z-index': 19,
                            'line-color': function(ele) {
                                return ele.data("color");
                            },
                            'target-arrow-color': function(ele) {
                                return ele.data("color");
                            },
                            label: function(ele) {
                                return ele.data("label");
                            }
                        }
                    },
                    {
                        selector: '.hidetext',
                        style: { 'text-opacity': 0 }
                    },
                    {
                        selector: ".dull",
                        style: { "z-index": 1, opacity: 0.2 }
                    },
                    { selector: ".nodeHover", style: { shape: "ellipse", "background-opacity": 0.9 } },
                    { selector: ".lineFixed", style: { "overlay-opacity": 0 } }
                ],
            });

            cy.txtHide = hideParam ? true : false; // 隐藏txt，默认隐藏关联关系

            // 画布点击动作            
            cy.on("tap", function(a) {
                if (a.target === cy) {
                    _isFocus = false;
                    activeNode = null;
                    cy.collection("node").removeClass("nodeActive");
                    cancelHighLight();                    
                }
                $('.node-float').hide();
            });

            // cy画布上 鼠标按下动作
            cy.on('mousedown', function() {
                var coreStyle = cy.style()._private.coreStyle;
                coreStyle['active-bg-color'].value = [0, 255, 0];
                coreStyle['active-bg-size'].pfValue = 0;
                event.stopPropagation();
                event.preventDefault();
            });

            // 节点点击
            cy.on('tap', 'node', function(evt) {            
                var node = evt.target;                
                if (node._private.style['z-index'].value == 20) {
                    _isFocus = true;
                    highLight([node._private.data.id], cy);
                    if (node.hasClass("nodeActive")) {
                        activeNode = null;
                        node.removeClass("nodeActive");
                        cy.collection("edge").removeClass("edgeActive");
                        
                    } else {
                        activeNode = node;
                        cy.collection("node").removeClass("nodeActive");
                        cy.collection("edge").removeClass("edgeActive");
                        node.addClass("nodeActive");
                        node.neighborhood("edge").removeClass("opacity");
                        node.neighborhood("edge").addClass("edgeActive");
                        node.neighborhood("edge").connectedNodes().removeClass("opacity");
                    }
                } else {
                    _isFocus = false;
                    activeNode = null;
                    cy.collection("node").removeClass("nodeActive");
                    cancelHighLight();
                }
                $('.node-float').find('#node-target').text(node._private.data.name);
                $('.node-float').find('.node-float-right').attr('data-code', node._private.data.id).attr('data-type',node._private.data.category);
                $('.node-float').show();
                event.stopPropagation();
                event.preventDefault();
            });

            // node节点上，鼠标按下动作(先于click，顺序大致为：vmosedown-tap-click)
            cy.on("vmousedown", "node", function(a) {
                a = a.target;
                if (!_isFocus) {
                    highLight([a._private.data.id], cy)
                }
            });
            // node节点上，鼠标点击(或拖动)释放动作
            cy.on("tapend", "node", function(a) {
                if (!_isFocus) {
                    cancelHighLight()
                }
            });

            // 边线点击
            cy.on("tap", "edge", function(a) {
                _isFocus = false;
                activeNode = null;
                cy.collection("node").removeClass("nodeActive");
                cancelHighLight()
            });

            // 节点：鼠标悬浮
            cy.on('mouseover', 'node', function(evt) {
                var node = evt.target;
                if (node._private.style['z-index'].value == 20) {
                    node.addClass("nodeHover");
                    if (!_isFocus) {
                        cy.collection("edge").removeClass("edgeShow");
                        cy.collection("edge").removeClass("edgeActive");
                        node.neighborhood("edge").addClass("edgeActive");
                    }
                    // if (moveTimeer) {
                    //     clearTimeout(moveTimeer);

                    // setTimeout(function() {
                    //     var b = evt.originalEvent || window.event,
                    //         b = "<div class='tips' style='font-size:12px;background:white;box-shadow:0px 0px 3px #999;border-radius:1px;opacity:1;padding:1px;padding-left:8px;padding-right:8px;display:none;position: absolute;left:" + (b.clientX +
                    //             10) + "px;top:" + (b.clientY + 10) + "px;'>" + node._private.data.name + "</div>";
                    //     $("body").append($(b));
                    //     $(".tips").fadeIn()
                    // }, 600);
                    // }
                }
                /* if (moveTimeer) {
                    clearTimeout(moveTimeer);
                }

                //cy.collection("edge").removeClass("edgeShow");
                cy.collection("edge").removeClass("edgeActive");
                node.neighborhood("edge").addClass("edgeActive");
                //node.neighborhood("edge").connectedNodes().removeClass("opacity"); 
                if (activeNode) {
                    activeNode.neighborhood("edge").addClass("edgeActive");
                } */
            });
            // 节点：鼠标移出
            cy.on('mouseout', 'node', function(evt) {
                // console.log('mouseout-node-1')
                // if (moveTimeer) {
                //     clearTimeout(moveTimeer);
                // }
                evt.target.removeClass("nodeHover");

                if (!_isFocus) {
                    cy.collection("edge").removeClass("edgeActive")
                }

                /* moveTimeer = setTimeout(function() {
                    cy.collection("edge").addClass("edgeActive");
                    //cy.collection("edge").addClass("edgeShow");
                }, 300);
                if (activeNode) {
                    activeNode.neighborhood("edge").addClass("edgeActive");
                } */
            });
            // 线：鼠标移出
            cy.on('mouseover', 'edge', function(evt) {
                // console.log('mouseover-edge-1')
                if (!_isFocus) {
                    var edge = evt.target;
                    cy.collection("edge").removeClass("edgeActive");
                    edge.addClass("edgeActive")
                    edge.removeClass("hidetext");
                }

                /* var edge = evt.target;
                if (moveTimeer) {
                    clearTimeout(moveTimeer);
                }
                cy.collection("edge").removeClass("edgeActive");
                edge.addClass("edgeActive");
                if (activeNode) {
                    activeNode.neighborhood("edge").addClass("edgeActive");
                } */
            });
            // 线：鼠标移出
            cy.on('mouseout', 'edge', function(evt) {
                // console.log('mouseout-edge-1')
                var edge = evt.target;
                if (!_isFocus) {
                    edge.removeClass("edgeActive");
                    activeNode && activeNode.neighborhood("edge").addClass("edgeActive")

                    if (!cy.txtHide) {
                        edge.addClass("hidetext");
                    }
                }

                /*  var edge = evt.target;
                 edge.removeClass("edgeActive");
                 moveTimeer = setTimeout(function() {
                     cy.collection("edge").addClass("edgeActive");
                     //cy.collection("edge").addClass("edgeShow");
                 }, 300);
                 if (activeNode) {
                     activeNode.neighborhood("edge").addClass("edgeActive");
                 } */
            });

            /* cy.on('tap', function(event) {                        
                // target holds a reference to the originator
                // of the event (core or element)
                var evtTarget = event.target;

                if (evtTarget === cy) {
                    activeNode = null;
                    cy.collection("node").removeClass("nodeActive");
                    //cy.collection("edge").addClass("edgeActive");
                } else {
                    console.log('tap on some element');
                }
            }); */

            cy.nodes().positions(function(a, b) {
                if (a._private.data.id === nodeCenter) {
                    return { x: 900, y: 900 }
                } else {
                    cy.pan({ x: clientWidth / 2, y: 100 });
                }
            });

            cy.ready(function() {
                if (levelParam) {
                    cy.zoom({ level: levelParam });
                } else {
                    var len = cy.collection("node").length;
                    if (len > 100) {
                        cy.zoom({ level: 0.8 });
                    } else if (len > 50) {
                        cy.zoom({ level: 0.9 });
                    } else {
                        cy.zoom({ level: 1.0000095043745896 });
                    }
                }

                setTimeout(function() {
                    cy.collection("edge").addClass("lineFixed")
                }, 400)

                $("#load_data").hide();

                // cy.$('#' + CompanyChart.companyCode).emit('tap');
                cy.center(cy.$('#' + nodeCenter));
                cy.$('#' + nodeCenter)[0]._isRoot = true;
            });
            cy.nodes(function(a) {})

            cy.on('zoom', function() {
                if (!cy.txtHide) {
                    if (cy.zoom() < 0.5) {
                        cy.collection("node").addClass("hidetext");
                    } else {
                        cy.collection("node").removeClass("hidetext");
                    }
                }
                setTimeout(function() {
                    cy.collection("edge").removeClass("lineFixed");
                    cy.collection("edge").addClass("lineFixed")
                }, 200)
            })

            cy.on("pan", function() {
                setTimeout(function() {
                    cy.collection("edge").removeClass("lineFixed");
                    cy.collection("edge").addClass("lineFixed")
                }, 200)
            });

            function highLight(c, b) {
                b.collection("node").removeClass("nodeActive");
                b.collection("edge").removeClass("edgeActive");
                b.collection("node").addClass("dull");
                b.collection("edge").addClass("dull");
                for (var a = 0; a < c.length; a++) {
                    var d = c[a];
                    b.nodes(function(a) {
                        if (a._private.data.id == d) {
                            a.removeClass("dull");
                            a.neighborhood("edge").removeClass("dull");
                            a.neighborhood("edge").addClass("edgeActive");
                            a.neighborhood("edge").connectedNodes().removeClass("dull");
                        }
                    })
                }
            }

            function cancelHighLight() {
                cy.collection("node").removeClass("nodeActive");
                cy.collection("edge").removeClass("edgeActive");
                cy.collection("node").removeClass("dull");
                cy.collection("edge").removeClass("dull")
            }

            cy._reload = maoRefresh;
        }

        function resizeScreen() {
            $(eleParam).parent('#screenArea').height(heightParam);
            $(eleParam).height($(eleParam).parent('#screenArea').height());
        }
        resizeScreen();
        getData();

        return cy;
    },
    formatPercent: function(str) {
        //格式化百分比
        if (parseFloat(str)) {
            return parseFloat(str).toFixed(2) + "%";
        } else {
            return "--";
        }
    },
    /**
     * 绘制实际控制人路径
     */
    drawActualcontrollerroute: function(root, param, thisRatio, controlname) {

        var totalLevel = 0; // 最高层级

        function getNodeLocation(nodes, links) {

            var distance = 190;
            var xDistance = 220;

            for (var i = 0; i < nodes.length; i++) {
                if (nodes[i].Depth > totalLevel) {
                    totalLevel = nodes[i].Depth;
                }
            }

            if (totalLevel > 5) {
                distance = distance - totalLevel * 6;
            }

            // TODO 纵向
            for (var i = 0; i < nodes.length; i++) {
                if (nodes[i].Depth + 0) {
                    // nodes[i].y = 200 + (totalLevel - nodes[i].Depth) * distance;
                    nodes[i].y = 80 + (totalLevel - nodes[i].Depth) * distance;
                } else {
                    // nodes[i].y = 200 + totalLevel * distance; // 目标公司Y轴位置
                    nodes[i].y = 80 + totalLevel * distance; // 目标公司Y轴位置
                }
            }

            for (var i = 0; i <= totalLevel; i++) {
                var temp = []; // 记录相同层级的节点
                for (var j = 0; j < nodes.length; j++) {
                    if (nodes[j].Depth == i) {
                        temp.push(nodes[j]);
                    }
                }

                for (var k = 0; k < temp.length; k++) {
                    temp[k].x = (width - (temp.length - 1) * xDistance) / 2 + xDistance * k;
                }
            }

            // 当所有路径与点刚好绘制成一个圆时 (三角形、菱形)
            if (links && links.length && nodes.length === links.length) {
                for (var i = 1; i < nodes.length - 1; i++) {
                    nodes[i].x = (width - i * xDistance) / 2 + xDistance * i;
                }
            }

            // TODO 横向
            // for (var i = 0; i < nodes.length; i++) {
            //     if (nodes[i].Depth + 0) {
            //         nodes[i].x = 200 + (totalLevel - nodes[i].Depth) * distance;
            //     } else {
            //         nodes[i].x = 200 + totalLevel * distance; // 目标公司Y轴位置
            //     }
            // }

            // for (var i = 0; i <= totalLevel; i++) {
            //     var temp = []; // 记录相同层级的节点
            //     for (var j = 0; j < nodes.length; j++) {
            //         if (nodes[j].Depth == i) {
            //             temp.push(nodes[j]);
            //         }
            //     }

            //     for (var k = 0; k < temp.length; k++) {
            //         temp[k].y = (width - (temp.length - 1) * xDistance) / 2 + xDistance * k;
            //     }
            // }

            // // 当所有路径与点刚好绘制成一个圆时 (三角形、菱形)
            // if (links && links.length && nodes.length === links.length) {
            //     for (var i = 1; i < nodes.length - 1; i++) {
            //         nodes[i].y = (width - i * xDistance) / 2 + xDistance * i;
            //     }
            // }

        }

        function zoomed() {
            // container.attr("transform", d3.event.transform);
            container.attr("transform", "translate(" + d3.event.translate + ")scale(" + d3.event.scale + ")");
        }

        function dragged(d) {
            var lines = svgLinks.selectAll("path");
            lines.attr("d", function(d) {
                var dx = d.target.x - d.source.x,
                    dy = d.target.y - d.source.y,
                    dr = Math.sqrt(dx * dx + dy * dy),
                    //theta = Math.atan2(dy, dx) + Math.PI / 7.85,
                    theta = Math.atan2(dy, dx) + Math.PI / 720,
                    d90 = Math.PI / 2,
                    dtxs = d.target.x - (d.target.r) * Math.cos(theta),
                    dtys = d.target.y - (d.target.r) * Math.sin(theta);
                return "M" + d.source.x + "," + d.source.y
                    //+ "A" + dr + "," + dr + " 0 0 1," + d.target.x + "," + d.target.y + "A" + dr + "," + dr + " 0 0 0," + d.source.x + "," + d.source.y
                    +
                    "L" + d.target.x + "," + d.target.y +
                    "M" + dtxs + "," + dtys + "l" + (3.5 * Math.cos(d90 - theta) - 10 * Math.cos(theta)) + "," + (-3.5 * Math.sin(d90 - theta) - 10 * Math.sin(theta)) + "L" + (dtxs - 3.5 * Math.cos(d90 - theta) - 10 * Math.cos(theta)) + "," + (dtys + 3.5 * Math.sin(d90 - theta) - 10 * Math.sin(theta)) + "z";
            });

            //更新连接线上文字的位置
            edges_text.attr("x", function(d) {
                return (d.source.x + d.target.x) / 2 - d.Ratio.length / 2 * 10;
            });

            edges_text.attr("y", function(d) {
                return (d.source.y + d.target.y) / 2 - 3;
            });

            edges_text.attr("transform", function(d) {
                var x = (d.source.x + d.target.x) / 2;
                var y = (d.source.y + d.target.y) / 2;
                var angle = 0;
                if (d.target.x - d.source.x == 0) {
                    if (d.target.y > d.source.y) {
                        angle = 90;
                    } else {
                        angle = -90
                    }
                } else {
                    angle = Math.atan((d.target.y - d.source.y) / (d.target.x - d.source.x)) * 180 / Math.PI;
                }
                return "rotate(" + angle + " " + x + "," + y + ")";
            });
            edges_rect.attr("transform", function(d) {
                var x = (d.source.x + d.target.x) / 2;
                var y = (d.source.y + d.target.y) / 2;
                var angle = 0;
                if (d.target.x - d.source.x == 0) {
                    if (d.target.y > d.source.y) {
                        angle = 90;
                    } else {
                        angle = -90
                    }
                } else {
                    angle = Math.atan((d.target.y - d.source.y) / (d.target.x - d.source.x)) * 180 / Math.PI;
                }
                return "rotate(" + angle + " " + x + "," + y + ")";
            });

            // d3.select(this).select("circle").attr("cx", d.x = d3.event.x).attr("cy", d.y = d3.event.y);
            d3.select(this).attr("transform", function(d) {
                d.x = d3.event.x;
                d.y = d3.event.y;
                return "translate(" + d3.event.x + "," + d3.event.y + ")";
            });
        }

        var width = document.querySelector('#companyChart').clientWidth;
        var height = document.querySelector('#companyChart').clientHeight;;

        if (!root.NodeList) {
            root.NodeList = [];
        }
        if (!root.RelationList) {
            root.RelationList = [];
        }

        root.NodeList.push({
            NodeId: param.companyCode,
            NodeName: param.rootName,
            Depth: 0
        });        
        if (root.RelationList.length == 0) {
            //如果没有数据的时候，把两个公司直接画线
            root.RelationList.push({
                OrigionId: param.secondCode,
                TargetId: param.companyCode
            });
        }
        var nodes = root.NodeList;
        var links = root.RelationList;

        for (var i = 0; i < links.length; i++) {
            if (links[i].Ratio) {
                links[i].Ratio += '';
            } else {
                //如果没有数据的时候，画线以后把父层表格
                if (thisRatio && links.length == 1) {
                    links[i].Ratio = thisRatio;
                } else {
                    links[i].Ratio = '0';
                }
            }
            if (!links[i].OrigionId) {
                links[i].OrigionId = param.secondCode;
            }
            if (!links[i].TargetId) {
                links[i].TargetId = param.companyCode;
            }
            if (links[i].Ratio.indexOf('.') > -1) {
                links[i].Ratio = (parseFloat(links[i].Ratio)).toFixed(2);
            }
        }

        for (var i = 0; i < root.NodeList.length; i++) {
            // 5 = 2+3, 保证其至少大于1
            root.NodeList[i].Grade = 2 + Math.floor(i / 3);
            // 目标公司
            if (root.NodeList[i].NodeId == param.companyCode) {
                root.NodeList[i].Grade = 1;
                root.NodeList[i].isRoot = true;
            } else if (param.ctrlIdArr.indexOf(root.NodeList[i].NodeId) > -1) {
                root.NodeList[i].isCtrl = true;
                root.NodeList[i].Grade = 1;
            }
            if (/^[\u4e00-\u9fa5]/.test(root.NodeList[i].NodeName)) { //中文名称
                if (root.NodeList[i].NodeName.length > 5) {
                    var depth = root.NodeList[i].NodeName.length / 5;
                    root.NodeList[i].r = ((Math.ceil(depth + 2) * 17) / 2) > 39 ? (Math.ceil(depth + 2) * 17) / 2 : 39;
                } else {
                    root.NodeList[i].r = ((root.NodeList[i].NodeName.length * 17) / 2) > 39 ? ((root.NodeList[i].NodeName.length * 17) / 2) : 39;
                }
            } else { //英文名称
                var enArr = root.NodeList[i].NodeName.split(' ');
                var maxLength = Math.max(enArr[0].length, enArr.length); //取单词最大长度或者行数最大作为计算半径的基础
                for (var el = 0; el < enArr.length; el++) {
                    maxLength = Math.max(maxLength, enArr[el].length);
                }
                root.NodeList[i].r = ((maxLength * 10) / 2) > 39 ? ((maxLength * 10) / 2) : 39;
            }
        }

        // 计算节点位置
        getNodeLocation(nodes, links);

        for (var i = 0; i < links.length; i++) {
            for (var j = 0; j < nodes.length; j++) {
                if (links[i].OrigionId == nodes[j].NodeId) {
                    links[i].source = nodes[j];
                }

                if (links[i].TargetId == nodes[j].NodeId) {
                    links[i].target = nodes[j];
                }
            }

        }

        document.querySelector('#companyChart').innerHTML = '';
        var zoom = window._CompanyChart.zoom = d3.behavior.zoom()
            .scaleExtent([1, 1])
            .on("zoom", zoomed);
        var svg = window._CompanyChart.svg = d3.select("#companyChart").append("svg").attr("xmlns", "http://www.w3.org/2000/svg");
        svg.empty();        
        d3.select('svg').attr("width", width);
        d3.select('svg').attr("height", height);
        var container = window._CompanyChart.container = svg.append("g");
        svg.call(zoom);
        var svgLinks = container.selectAll(".link").
        data(links)
            .enter()
            .append("g");
        var svgNodes = container.selectAll(".node")
            .data(nodes)
            .enter()
            .append("g")
            .attr("transform", function(d) {
                return "translate(" + d.x + "," + d.y + ")";
            })
            // .call(d3.behavior.drag()
            //     .on("drag", dragged)
            // )
            // .on("click", function(d) {
            //     if (d.Type == 'person' && d.IsLinkable && d.NodeId) {
            //         window.open('Person.html?id=' + d.NodeId + '&name=' + d.NodeName + Common.isNoToolbar());
            //         return;
            //     }
            //     if (d.IsLinkable && d.NodeId) {
            //         Common.linkCompany("Bu3", d.NodeId);
            //     }
            // });

        var dragCall = d3.behavior.drag()
            .on("drag", function() {
                var attr = container.attr('transform');
                var xy = attr.split(')')[0].split('(')[1].split(',');
                var s = attr.split('scale(')[1].split(')')[0] - 0;
                var x0 = (xy[0] - 0);
                var y0 = (xy[1] - 0);
                var x = Math.abs(xy[0] - 0);
                var y = Math.abs(xy[1] - 0);
                var maxX = $('#companyChart').width() / 2;
                var maxY = ($('#companyChart').height() - 20) / 2;
                if (x > maxX || y > maxY) {
                    if (x > maxX && y > maxY) {
                        container.transition()
                            .duration(500)
                            .attr("transform", "translate(" + [x0 < 0 ? -maxX : maxX, y0 < 0 ? -maxY : maxY] + ")scale(" + s + ")");
                        zoom.translate([3, 3]);
                    } else if (x > maxX) {
                        container.transition()
                            .duration(500)
                            .attr("transform", "translate(" + [x0 < 0 ? -maxX : maxX, y0] + ")scale(" + s + ")");
                        zoom.translate([x0 < 0 ? -maxX : maxX, y0]);
                    } else {
                        container.transition()
                            .duration(500)
                            .attr("transform", "translate(" + [x0, y0 < 0 ? -maxY : maxY] + ")scale(" + s + ")");
                        zoom.translate([x0, y0 < 0 ? -maxY : maxY]);
                    }
                }
            });
        svg.call(dragCall);

        svgLinks.append("path")
            .style("fill", "#aaa")
            .style("stroke", "#aaa")
            .style("stroke-opacity", ".5")
            .attr("d", function(d) {
                var dx = d.target.x - d.source.x,
                    dy = d.target.y - d.source.y,
                    dr = Math.sqrt(dx * dx + dy * dy),
                    theta = Math.atan2(dy, dx) + Math.PI / 720,
                    d90 = Math.PI / 2,
                    dtxs = d.target.x - (d.target.r) * Math.cos(theta),
                    dtys = d.target.y - (d.target.r) * Math.sin(theta);
                return "M" + d.source.x + "," + d.source.y +
                    "L" + d.target.x + "," + d.target.y +
                    "M" + dtxs + "," + dtys + "l" + (3.5 * Math.cos(d90 - theta) - 10 * Math.cos(theta)) + "," + (-3.5 * Math.sin(d90 - theta) - 10 * Math.sin(theta)) + "L" + (dtxs - 3.5 * Math.cos(d90 - theta) - 10 * Math.cos(theta)) + "," + (dtys + 3.5 * Math.sin(d90 - theta) - 10 * Math.sin(theta)) + "z";
            });


        svgLinks.each(function(d) {
            d3.select(this).append("text")
                .attr("class", "linetext")
                .attr("fill", function(d) {
                    if (d.Ratio == '100') {
                        return "#B91818";
                    } else {
                        return "#50AFC6";
                    }
                })
                .attr("fill-opacity", 1)
                .text(function(d) {
                    if (d.Ratio && d.Ratio != '?') {
                        return d.Ratio * 100 / 100 + '%';
                    } else {
                        return '';
                    }
                });
        });

        initLocation();

        var edges_text = svgLinks.selectAll(".linetext");
        var edges_rect = svgLinks.selectAll(".linerect");
        edges_text.attr("font-size", "12px");
        edges_text.attr("x", function(d) {
            if (d.source.x > d.target.x) {
                return (d.source.x + d.target.x - (d.Ratio.length) * 10) / 2;
            }
            return (d.source.x + d.target.x) / 2 - d.Ratio.length / 2 * 10;
        });

        edges_text.attr("y", function(d) {
            if (d.source.y > d.target.y) {
                return (d.source.y + d.target.y) / 2 - 3;
            }
            return (d.source.y + d.target.y) / 2 + 3;
        });


        edges_text.attr("transform", function(d) {
            var x = (d.source.x + d.target.x) / 2;
            var y = (d.source.y + d.target.y) / 2;
            var angle = 0;
            if (d.target.x - d.source.x == 0) {
                if (d.target.y > d.source.y) {
                    angle = 90;
                } else {
                    angle = -90
                }
            } else {
                angle = Math.atan((d.target.y - d.source.y) / (d.target.x - d.source.x)) * 180 / Math.PI;
            }
            return "rotate(" + angle + " " + x + "," + y + ")";
        });

        svgNodes.append("circle")
            .attr("r", function(d) {
                return d.r;
            })
            .attr("style", "cursor: pointer;")
            .attr("fill", function(d) {
                if (d.isRoot) {
                    return "#FE9D4E";
                }
                if (d.isCtrl || d.NodeName == controlname) {
                    return "#B91818";
                } else {
                    return "#50AFC6";
                }

            });
        svgNodes.each(function(d, i) {
            if (/^[\u4e00-\u9fa5]/.test(d.NodeName)) {
                var lines = Math.ceil(d.NodeName.length / 5);
                var text = "";
                //          	var dx = 0;
                var dy = 0;
                for (var line = 0; line < lines; line++) {
                    if (d.CategoryId == 2) {
                        //                  	dx = 0 - d.NodeName.length * 5;
                        dy = 3;
                        d3.select(this)
                            .append("text")
                            .attr("style", "cursor: pointer;")
                            //                      	.attr("dx", dx - 2)
                            .attr("dy", dy)
                            .attr("fill", "#fff")
                            .attr("font-size", "12px")
                            .text(d.NodeName)
                            .on('click', function(d) {
                                if (d.Type == 'person' && d.IsLinkable && d.NodeId) {
                                    Common.chartCardEventHandler({ companyCode: d.NodeId, title: '人物信息', type: 'person', name: d.NodeName })
                                        // window.open('Person.html?id=' + d.NodeId + '&name=' + d.NodeName + Common.isNoToolbar());
                                    return;
                                }
                                if (d.IsLinkable && d.NodeId) {
                                    Common.chartCardEventHandler({ companyCode: d.NodeId, title: '企业信息', type: 'company', name: d.NodeName })
                                        // Common.linkCompany("Bu3", d.NodeId);
                                }
                            })
                            .style("text-anchor", "middle");
                    } else if (lines == 1) {
                        //	                    dx = -13-(d.NodeName.length-2)*5;
                        dy = 5;

                        d3.select(this)
                            .append("text")
                            .attr("style", "cursor: pointer;")
                            //                      	.attr("dx", dx)
                            .attr("dy", dy)
                            .attr("font-size", "12px")
                            .attr("fill", "#fff")
                            .text(d.NodeName.substr(line * 5, 5))
                            .on('click', function(d) {
                                if (d.Type == 'person' && d.IsLinkable && d.NodeId) {
                                    // window.open('Person.html?id=' + d.NodeId + '&name=' + d.NodeName + Common.isNoToolbar());
                                    Common.chartCardEventHandler({ companyCode: d.NodeId, title: '人物信息', type: 'person', name: d.NodeName })
                                    return;
                                }
                                if (d.IsLinkable && d.NodeId) {
                                    // Common.linkCompany("Bu3", d.NodeId);
                                    Common.chartCardEventHandler({ companyCode: d.NodeId, title: '企业信息', type: 'company', name: d.NodeName })
                                }
                            })
                            .style("text-anchor", "middle");
                    } else {
                        //              		dx = -10 * 2.5;
                        //                  	if (line == (lines - 1)) {
                        //                      	dx = 0 - 5 * (d.NodeName.substr(line * 5, 5).length);
                        //                  	}
                        dy = 13 * line - lines * 2.5;

                        d3.select(this)
                            .append("text")
                            .attr("style", "cursor: pointer;")
                            //                      	.attr("dx", dx - 4)
                            .attr("dy", dy)
                            .attr("font-size", "12px")
                            .attr("fill", "#fff")
                            .text(d.NodeName.substr(line * 5, 5))
                            .on('click', function(d) {
                                // if (d.Type == 'person' && d.IsLinkable && d.NodeId) {
                                //     Common.chartCardEventHandler({ companyCode: d.NodeId, title: '人物信息', type: 'person', name: d.NodeName })
                                //         // window.open('Person.html?id=' + d.NodeId + '&name=' + d.NodeName + Common.isNoToolbar());
                                //     return;
                                // }
                                // if (d.IsLinkable && d.NodeId) {
                                //     Common.chartCardEventHandler({ companyCode: d.NodeId, title: '企业信息', type: 'company', name: d.NodeName })
                                //         // Common.linkCompany("Bu3", d.NodeId);
                                // }
                            })
                            .style("text-anchor", "middle");
                    }

                }
            } else {
                var lineArr = d.NodeName.split(' ');
                var lineNum = d.NodeName.split(' ').length;
                if (d.NodeName.split(' ').length % 2 == 0) {
                    var dyy = -2.5;
                } else {
                    var dyy = 5;
                }
                var tent = Math.ceil(lineNum / 2);
                var tentArr = [];
                var tentStr = 0;
                for (var tentl = lineNum; tentl > 0; tentl--) {
                    tentStr = tent - tentl;
                    tentArr.push(tentStr);
                }
                var text = "";
                //          	var dx = 0;
                var dy = 5;
                for (var tl = 0; tl < lineNum; tl++) {
                    //          		dx=0-Math.ceil(lineArr[tl].length / 2)*6;
                    dy = dyy + tentArr[tl] * 11;

                    d3.select(this)
                        .append("text")
                        .attr("style", "cursor: pointer;")
                        //                      .attr("dx", dx)
                        .attr("dy", dy)
                        .attr("font-size", "12px")
                        .attr("fill", "#fff")
                        .text(lineArr[tl])
                        .style("text-anchor", "middle");
                }
            }
        });

        function initLocation() {
            zoom.translate([0, 0]);
            zoom.scale(1);
            container.attr("transform", "translate(" + 0 + "," + 0 + ")scale(" + zoom.scale() + ")");
        }
    },
    getOSType: function (){
        var u = navigator.userAgent;
        var browserType = {
            android: u.indexOf('Android') > -1 || u.indexOf('Adr') > -1, // android
            ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), // ios        
        };
        if (browserType.ios) {
            return 'ios';
        } else if (browserType.android) {
            return 'android';
        } 
        return '';
    },
    pathDataChange: function(data, notControlLenth) {
        var paths = data.paths;
        var nodeObj = {}; // node 对象，有唯一key
        var routeObj = {}; // route 对象，有唯一key
        var nodes = []; // node arr
        var links = []; // route arr

        for (var i = 0; i < paths.length; i++) {
            var nodeInPath = paths[i].nodes;

            // 是否限制长度
            if (!notControlLenth) {
                if (nodeInPath.length > 3) {
                    nodeInPath.length = 3;
                }
            }

            for (var j = 0; j < nodeInPath.length; j++) {
                var node = nodeInPath[j];
                if (!nodeObj[node.windId]) {
                    nodeObj[node.windId] = node;
                    nodes.push(node);
                } else {
                    nodeObj[node.windId].level = node.level;
                }
            }
        }

        for (var i = 0; i < data.routes.length; i++) {
            var route = data.routes[i];
            var startId = route.startId;
            var endId = route.endId;
            var _routeId = route.startId + '_' + route.endId;
            route._routeId = _routeId;
            if (nodeObj[startId] && nodeObj[endId]) {
                links.push(route);
            }
            if (!routeObj[_routeId]) {
                routeObj[_routeId] = route;
            }
        }
        return { nodes: nodes, routes: links, nodeObj: nodeObj, routeObj: routeObj };
    },
    pathChange: function(paths) {
        var tmp = _GEL_CHART_COMMON_.chartPathChange(paths);
        window._CompanyChart.filterPathObj = tmp.filterPathObj;
        window._CompanyChart.allPathObj = tmp.allPathObj;
        window._CompanyChart.statePathObj = tmp.statePathObj;
        return tmp;
    },
    buryForAd: function (params) {
        try{
            /** 用于图谱页面埋点信息获取 */
            setTimeout(() => {
                if(window.localStorage.GelRecords == undefined){ // 埋点信息存储在 storage 中
                    var recordsArr = new Array();
                    window.localStorage.GelRecords=JSON.stringify(recordsArr);  
                }
                var records = JSON.parse(window.localStorage.GelRecords);
    
                var regexPage = /\/\/[^/]+\/[^/]+\/([\S]+)\.html/;
                var loadingPageHtml = location.href.match(regexPage)?location.href.match(regexPage)[1].split('/'):null;
                var loadingPage = loadingPageHtml?loadingPageHtml[loadingPageHtml.length-1].toLowerCase():null;
    
                var otherFuncCodeDic = {
                    /** 用来区分功能点 */
                    'gqct' : '922602100723,股权穿透', // GEAPP-企业详情页-加载股权穿透图
                    'ysgx' : '922602100724,疑似关系', // GEAPP-企业详情页-加载疑似关系图
                    'gqjg' : '922602100725,股权结构', // GEAPP-企业详情页-加载股权结构图
                    'zzsyr' : '922602100726,企业受益人', // GEAPP-企业详情页-加载企业受益人图
                };
                
                
                var fromModule = _GEL_CHART_COMMON_.getUrlSearch('fromModule') || null;
                var funCodeEntity = otherFuncCodeDic[loadingPage] ? otherFuncCodeDic[loadingPage] : '';
                var osTypeBury = _GEL_CHART_COMMON_.getOSType() || null;
    
                if(funCodeEntity){
                    var funCode = funCodeEntity.split(',')[0] || null;
                    var buryEntity =  funCodeEntity.split(',')[1] ||null;
        
                    var moreParam = {d:null, ee:'mobile', f:null, g:null, h:null, i:null, j:null, k:null, l:null, mm:osTypeBury, n:null, oo:null, p:null, q:null, r:'wft', s : fromModule,t : null, u : null};
                    records.push({a:funCode, b:'otherFunc', c: buryEntity, fromAppParam:moreParam});
                    window.localStorage.setItem('GelRecords', JSON.stringify(records)); 
                }
    
            },50)
        }catch(e){}
    }
}

_GEL_CHART_COMMON_.buryForAd();